diff --git a/test/unit/daemon/auto_retry_probe_test.rb b/test/unit/daemon/auto_retry_probe_test.rb
new file mode 100644
index 00000000..969b98e0
--- /dev/null
+++ b/test/unit/daemon/auto_retry_probe_test.rb
@@ -0,0 +1,333 @@
+require "test_helper"
+require "hive/config"
+require "hive/daemon/auto_retry_probe"
+
+class AutoRetryProbeTest < Minitest::Test
+  include HiveTestHelper
+
+  FakeDoctor = Struct.new(:result) do
+    def required_checks
+      result
+    end
+  end
+
+  def test_codex_chain_requires_doctor_login_and_smoke_and_uses_isolated_cwd
+    with_tmp_dir do |project|
+      calls = []
+      runner = lambda do |**args|
+        calls << args
+        probe_result(args[:name], healthy: true)
+      end
+      probe = build_probe(project, runner: runner)
+
+      aggregate = probe.call(reason: "implementer_failed")
+
+      assert aggregate.healthy
+      assert_equal %w[required_doctor codex_login_status codex_exec_smoke],
+                   aggregate.probes.map(&:name)
+      smoke = calls.find { |call| call[:name] == "codex_exec_smoke" }
+      refute_equal project, smoke[:chdir]
+      refute smoke[:chdir].start_with?(project + File::SEPARATOR)
+      assert_equal 30, smoke[:timeout_sec]
+      assert_equal "/fake/codex", smoke[:env]["HIVE_CODEX_BIN"]
+      assert_includes smoke[:argv], "--skip-git-repo-check"
+      assert_includes smoke[:argv], "read-only"
+      assert_includes smoke[:argv], "--ephemeral"
+      assert_includes smoke[:argv], "shell_environment_policy.inherit=none"
+      refute_includes smoke[:argv], "--ignore-user-config"
+      refute_includes smoke[:argv], "--dangerously-bypass-approvals-and-sandbox"
+    end
+  end
+
+  def test_unhealthy_command_or_doctor_blocks_aggregate
+    with_tmp_dir do |project|
+      runner = lambda do |**args|
+        probe_result(args[:name], healthy: args[:name] != "codex_login_status",
+                                  exit_status: 1)
+      end
+      aggregate = build_probe(project, runner: runner).call(reason: "implementer_failed")
+      refute aggregate.healthy
+      refute aggregate.probes.find { |probe| probe.name == "codex_login_status" }.healthy
+
+      doctor = FakeDoctor.new({ healthy: false, rows: [], error: "missing skill" })
+      aggregate = build_probe(project, runner: runner, doctor: doctor)
+                  .call(reason: "implementer_failed")
+      refute aggregate.healthy
+      assert_equal "missing skill", aggregate.probes.first.rationale
+    end
+  end
+
+  def test_claude_chain_checks_wrapper_detector_identity_and_binary
+    with_tmp_dir do |project|
+      identity = Hive::InvokedBinary.loaded_identity
+      runner = lambda do |**args|
+        stdout = args[:name] == "hive_install_identity" ? JSON.generate(identity) : "Claude 2.1.999"
+        probe_result(args[:name], healthy: true, stdout: stdout)
+      end
+
+      aggregate = build_probe(project, runner: runner).call(reason: "claude_launch_failed")
+
+      assert aggregate.healthy, aggregate.probes.map(&:to_h).inspect
+      assert_equal %w[
+        required_doctor claude_wrapper claude_readiness_detector
+        hive_install_identity claude_binary
+      ], aggregate.probes.map(&:name)
+    end
+  end
+
+  def test_identity_mismatch_blocks_claude_recovery
+    with_tmp_dir do |project|
+      runner = lambda do |**args|
+        stdout = if args[:name] == "hive_install_identity"
+          JSON.generate("version" => Hive::VERSION, "fingerprint" => "other-install")
+        else
+          ""
+        end
+        probe_result(args[:name], healthy: true, stdout: stdout)
+      end
+      aggregate = build_probe(project, runner: runner).call(reason: "claude_launch_failed")
+      refute aggregate.healthy
+      identity = aggregate.probes.find { |probe| probe.name == "hive_install_identity" }
+      assert_equal "daemon and CLI installation identities differ", identity.rationale
+    end
+  end
+
+  def test_probe_outputs_are_redacted_bounded_and_fingerprints_are_stable
+    with_tmp_dir do |project|
+      secret = "Authorization: Bearer abcdefghijklmnopqrstuvwxyz"
+      invocation = 0
+      runner = lambda do |**args|
+        invocation += 1
+        probe_result(
+          args[:name], healthy: true,
+          stdout: "#{secret}#{invocation}-#{"x" * 10_000}"
+        )
+      end
+      probe = build_probe(project, runner: runner)
+      first = probe.call(reason: "implementer_failed")
+      second = probe.call(reason: "implementer_failed")
+
+      assert_equal first.fingerprint, second.fingerprint
+      first.probes.each do |result|
+        refute_includes result.stdout, "abcdefghijklmnopqrstuvwxyz"
+        assert_operator result.stdout.bytesize, :<=, Hive::Daemon::AutoRetryProbe::MAX_CAPTURE_BYTES
+      end
+    end
+  end
+
+  def test_required_skill_inventory_changes_the_cheap_fingerprint
+    with_tmp_dir do |project|
+      doctor = FakeDoctor.new(
+        { healthy: false, rows: [ { kind: "skill", name: "missing", status: "missing" } ] }
+      )
+      before = build_probe(project, runner: ->(**args) {
+        probe_result(args[:name], healthy: true)
+      }, doctor: doctor).cheap_fingerprint(reason: "implementer_failed")
+
+      doctor.result = {
+        healthy: true,
+        rows: [ { kind: "skill", name: "missing", status: "ok", path: "/skills/missing" } ]
+      }
+      after = build_probe(project, runner: ->(**args) {
+        probe_result(args[:name], healthy: true)
+      }, doctor: doctor).cheap_fingerprint(reason: "implementer_failed")
+
+      refute_equal before, after
+    end
+  end
+
+  def test_cheap_fingerprints_ignore_the_other_reasons_dependency_signals
+    with_tmp_dir do |project|
+      runner = ->(**args) { probe_result(args[:name], healthy: true) }
+      base_env = ENV.to_h.merge(
+        "HIVE_CODEX_BIN" => "/fake/codex-a",
+        "HIVE_CLAUDE_BIN" => "/fake/claude-a"
+      )
+      base = build_probe(project, runner: runner, env: base_env)
+      codex_before = base.cheap_fingerprint(reason: "implementer_failed")
+      claude_before = base.cheap_fingerprint(reason: "claude_launch_failed")
+
+      claude_changed = build_probe(
+        project, runner: runner,
+        env: base_env.merge("HIVE_CLAUDE_BIN" => "/fake/claude-b")
+      )
+      assert_equal codex_before,
+                   claude_changed.cheap_fingerprint(reason: "implementer_failed")
+      refute_equal claude_before,
+                   claude_changed.cheap_fingerprint(reason: "claude_launch_failed")
+
+      codex_changed = build_probe(
+        project, runner: runner,
+        env: base_env.merge("HIVE_CODEX_BIN" => "/fake/codex-b")
+      )
+      refute_equal codex_before,
+                   codex_changed.cheap_fingerprint(reason: "implementer_failed")
+      assert_equal claude_before,
+                   codex_changed.cheap_fingerprint(reason: "claude_launch_failed")
+    end
+  end
+
+  def test_real_runner_times_out_and_marks_result_unhealthy
+    with_tmp_dir do |project|
+      script = File.join(project, "hang")
+      File.write(script, "#!/bin/sh\nsleep 5\n")
+      File.chmod(0o755, script)
+      probe = build_probe(project, runner: nil)
+      result = probe.send(
+        :run_command,
+        name: "hang", argv: [ script ], env: ENV.to_h,
+        chdir: project, timeout_sec: 0.05
+      )
+
+      refute result.healthy
+      assert result.timed_out
+      assert_includes result.rationale, "timed out"
+    end
+  end
+
+  def test_real_runner_does_not_wait_for_descendant_that_inherits_output
+    with_tmp_dir do |project|
+      script = File.join(project, "orphan-output")
+      File.write(script, <<~RUBY)
+        #!/usr/bin/env ruby
+        spawn("sleep", "5")
+        puts "leader done"
+        exit! 0
+      RUBY
+      File.chmod(0o755, script)
+      probe = build_probe(project, runner: nil)
+      started = Process.clock_gettime(Process::CLOCK_MONOTONIC)
+      result = probe.send(
+        :run_command,
+        name: "orphan-output", argv: [ script ], env: ENV.to_h,
+        chdir: project, timeout_sec: 1
+      )
+      elapsed = Process.clock_gettime(Process::CLOCK_MONOTONIC) - started
+
+      assert result.healthy
+      assert_operator elapsed, :<, 1
+    end
+  end
+
+  def test_default_doctor_and_doctor_failure_modes_are_structured
+    with_tmp_dir do |project|
+      probe = Hive::Daemon::AutoRetryProbe.new(
+        config: Hive::Config::DEFAULTS,
+        project_root: project,
+        command_runner: ->(**args) { probe_result(args[:name], healthy: true) }
+      )
+      assert_equal "required_doctor", probe.send(:doctor_probe).name
+
+      timed_out = build_probe(
+        project, runner: ->(**args) { probe_result(args[:name], healthy: true) },
+        doctor: Object.new.tap do |doctor|
+          doctor.define_singleton_method(:required_checks) { raise Timeout::Error }
+        end
+      ).send(:doctor_probe)
+      assert timed_out.timed_out
+
+      raised = build_probe(
+        project, runner: ->(**args) { probe_result(args[:name], healthy: true) },
+        doctor: Object.new.tap do |doctor|
+          doctor.define_singleton_method(:required_checks) { raise "doctor exploded" }
+        end
+      ).send(:doctor_probe)
+      refute raised.healthy
+      assert_includes raised.rationale, "doctor exploded"
+    end
+  end
+
+  def test_probe_setup_and_aggregate_errors_become_unhealthy_results
+    with_tmp_dir do |project|
+      raising_runner = ->(**) { raise Errno::ENOENT, "codex" }
+      setup = build_probe(project, runner: raising_runner)
+              .call(reason: "implementer_failed")
+      refute setup.healthy
+      assert_equal "codex_probe_setup", setup.probes.last.name
+
+      nil_runner = ->(**) { nil }
+      aggregate = build_probe(project, runner: nil_runner)
+                  .call(reason: "implementer_failed")
+      refute aggregate.healthy
+      assert_equal "probe_aggregate", aggregate.probes.first.name
+    end
+  end
+
+  def test_claude_local_probe_failures_are_structured
+    with_tmp_dir do |project|
+      probe = build_probe(
+        project,
+        runner: ->(**args) {
+          probe_result(args[:name], healthy: true, stdout: "not-json")
+        }
+      )
+      invalid = probe.send(:hive_identity_probe)
+      refute invalid.healthy
+      assert_includes invalid.rationale, "invalid CLI identity JSON"
+
+      with_replaced_singleton_method(
+        Hive::ClaudeLauncher, :interactive_wrapper_path,
+        -> { raise Errno::EACCES, "wrapper" }
+      ) do
+        refute probe.send(:wrapper_probe).healthy
+        assert_equal [ "wrapper", "unresolved" ], probe.send(:wrapper_signal)
+      end
+
+      with_replaced_singleton_method(
+        Hive::AgentProfiles, :lookup, ->(*) { raise KeyError, "profile" }
+      ) do
+        refute probe.send(:claude_binary_probe).healthy
+      end
+    end
+  end
+
+  def test_command_spawn_errors_are_structured
+    with_tmp_dir do |project|
+      probe = build_probe(project, runner: nil)
+      missing = probe.send(
+        :run_command, name: "missing", argv: [ File.join(project, "missing") ],
+        env: ENV.to_h, chdir: project, timeout_sec: 1
+      )
+      refute missing.healthy
+      assert_includes missing.rationale, "failed to start"
+    end
+  end
+
+  def test_unresolved_binary_and_cheap_fingerprint_error_have_stable_fallbacks
+    with_tmp_dir do |project|
+      probe = build_probe(project, runner: ->(**args) {
+        probe_result(args[:name], healthy: true)
+      })
+      assert_equal "definitely-missing",
+                   probe.send(:resolve_binary, "definitely-missing")
+      probe.define_singleton_method(:cheap_fingerprint) do |reason:|
+        raise TypeError, reason
+      end
+      fallback = probe.send(:safe_cheap_fingerprint, reason: "implementer_failed")
+      assert_match(/\A[0-9a-f]{64}\z/, fallback)
+    end
+  end
+
+  private
+
+  def build_probe(project, runner:, doctor: FakeDoctor.new({ healthy: true, rows: [] }),
+                  env: ENV.to_h.merge("HIVE_CODEX_BIN" => "/fake/codex"))
+    kwargs = {
+      config: Hive::Config::DEFAULTS,
+      project_root: project,
+      hive_bin: File.expand_path("../../../bin/hive", __dir__),
+      env: env,
+      doctor_factory: -> { doctor }
+    }
+    kwargs[:command_runner] = runner if runner
+    Hive::Daemon::AutoRetryProbe.new(**kwargs)
+  end
+
+  def probe_result(name, healthy:, stdout: "", stderr: "", exit_status: 0)
+    Hive::Daemon::AutoRetryProbe::ProbeResult.new(
+      name: name, healthy: healthy, exit_status: exit_status,
+      timed_out: false, duration_ms: 1, stdout: stdout, stderr: stderr,
+      rationale: healthy ? "command succeeded" : "command failed"
+    )
+  end
+end
diff --git a/test/unit/daemon/auto_retry_test.rb b/test/unit/daemon/auto_retry_test.rb
new file mode 100644
index 00000000..7f60dca2
--- /dev/null
+++ b/test/unit/daemon/auto_retry_test.rb
@@ -0,0 +1,504 @@
+require "test_helper"
+require "hive/daemon/auto_retry"
+require "hive/daemon/auto_retry_policy"
+require "hive/daemon/auto_retry_probe"
+require "hive/daemon/status_consumer"
+
+class AutoRetryTest < Minitest::Test
+  include HiveTestHelper
+
+  FakePolicyDecision = Struct.new(
+    :eligible, :action, :rationale, :reason, :marker_id, :task,
+    keyword_init: true
+  )
+  FakePolicy = Struct.new(:decision) do
+    def evaluate(_row)
+      decision
+    end
+  end
+  FakeProbe = Struct.new(:aggregate) do
+    def cheap_fingerprint(reason:)
+      raise "wrong reason" unless reason == aggregate.reason
+
+      aggregate.cheap_fingerprint
+    end
+
+    def call(reason:)
+      raise "wrong reason" unless reason == aggregate.reason
+
+      aggregate
+    end
+  end
+  FailingQueue = Module.new do
+    def self.pending(**)
+      []
+    end
+
+    def self.write_request!(**)
+      raise Errno::ENOSPC
+    end
+  end
+  RacingMarkers = Module.new do
+    def self.clear_current(*, **)
+      false
+    end
+  end
+  ClaimedRaceQueue = Module.new do
+    def self.pending(**)
+      []
+    end
+
+    def self.write_request!(**)
+      "claimed-request"
+    end
+
+    def self.remove_if_unclaimed(*, **)
+      false
+    end
+  end
+  FailingClearEvents = Module.new do
+    def self.emit_required(**)
+      nil
+    end
+
+    def self.emit(**)
+      nil
+    end
+  end
+  FailedReservationHistory = Struct.new(:decision) do
+    def budget(**)
+      decision
+    end
+
+    def assess(**)
+      decision
+    end
+
+    def reserve!(**)
+      false
+    end
+  end
+
+  def test_first_healthy_attempt_reserves_queues_and_guardedly_clears
+    with_fixture do |fixture|
+      retryer = fixture.retryer
+      result = retryer.tick([ fixture.row ], now: fixture.now).first
+
+      assert_equal "retry_queued", result.action
+      assert_equal 1, result.attempt
+      assert_equal :none, Hive::Markers.current(fixture.state_file).name
+      request = Hive::Daemon::DispatchRequestQueue.pending(state_home: fixture.state_home).first
+      assert_equal [
+        "hive", "run", fixture.row.slug, "--project", fixture.row.project,
+        "--stage", fixture.row.stage
+      ], request.argv
+      assert_equal "healer", request.requestor
+      assert_equal "marker-1", request.expected_cleared_marker_id
+      refute Hive::Daemon::DispatchRequestQueue.expired?(
+        request, now: fixture.now + 86_400
+      )
+
+      events = read_events(fixture.folder)
+      event_types = events.map { |event| event["event_type"] }
+      assert_includes event_types, "auto_retry_reserved"
+      assert_includes event_types, "marker_cleared"
+      retry_events = events.select do |event|
+        %w[auto_retry_reserved marker_cleared].include?(event["event_type"])
+      end
+      assert retry_events.all? { |event| event.dig("details", "task_id") == 42 }
+    end
+  end
+
+  def test_second_attempt_requires_changed_health_and_backoff_and_then_exhausts
+    with_fixture do |fixture|
+      first = fixture.retryer.tick([ fixture.row ], now: fixture.now).first
+      assert_equal "retry_queued", first.action
+      fixture.restore_marker("marker-2")
+
+      early = fixture.retryer(fingerprint: "health-b")
+                     .tick([ fixture.row ], now: fixture.now + 1799).first
+      assert_equal "retry_backoff", early.action
+
+      unchanged = fixture.retryer(fingerprint: "health-a")
+                         .tick([ fixture.row ], now: fixture.now + 1800).first
+      assert_equal "health_unchanged", unchanged.action
+
+      second = fixture.retryer(fingerprint: "health-b")
+                      .tick([ fixture.row ], now: fixture.now + 1800).first
+      assert_equal "retry_queued", second.action
+      assert_equal 2, second.attempt
+      fixture.restore_marker("marker-3")
+
+      exhausted = fixture.retryer(fingerprint: "health-c")
+                         .tick([ fixture.row ], now: fixture.now + 3600).first
+      assert_equal "retry_exhausted", exhausted.action
+      assert_equal :error, Hive::Markers.current(fixture.state_file).name
+    end
+  end
+
+  def test_marker_race_withdraws_unclaimed_request
+    with_fixture do |fixture|
+      result = fixture.retryer(markers: RacingMarkers)
+                      .tick([ fixture.row ], now: fixture.now).first
+
+      assert_equal "marker_race", result.action
+      assert_empty Hive::Daemon::DispatchRequestQueue.pending(state_home: fixture.state_home)
+      assert_equal :error, Hive::Markers.current(fixture.state_file).name
+    end
+  end
+
+  def test_queue_failure_leaves_marker_and_consumes_fail_closed_reservation
+    with_fixture do |fixture|
+      result = fixture.retryer(request_queue: FailingQueue)
+                      .tick([ fixture.row ], now: fixture.now).first
+
+      assert_equal "queue_failed", result.action
+      assert_equal :error, Hive::Markers.current(fixture.state_file).name
+      assert_equal "retry_backoff",
+                   Hive::Daemon::AutoRetryHistory.new.budget(
+                     task_folder: fixture.folder, reason: fixture.reason,
+                     now: fixture.now + 1
+                   ).action
+    end
+  end
+
+  def test_clear_audit_failure_rolls_marker_back_and_does_not_report_success
+    with_fixture do |fixture|
+      result = fixture.retryer(events: FailingClearEvents)
+                      .tick([ fixture.row ], now: fixture.now).first
+
+      assert_equal "coordinator_error", result.action
+      assert_equal :error, Hive::Markers.current(fixture.state_file).name
+      assert_equal 1,
+                   Hive::Daemon::DispatchRequestQueue.pending(
+                     state_home: fixture.state_home
+                   ).length
+    end
+  end
+
+  def test_restart_resumes_preclear_guarded_request_without_duplicating_it
+    with_fixture do |fixture|
+      history = Hive::Daemon::AutoRetryHistory.new
+      assert history.reserve!(
+        task_folder: fixture.folder, task_id: fixture.row.id,
+        slug: fixture.row.slug, stage: fixture.row.stage,
+        marker_id: "marker-1", reason: fixture.reason,
+        fingerprint: "health-a", attempt: 1, probes: [],
+        now: fixture.now
+      )
+      Hive::Daemon::DispatchRequestQueue.write_request!(
+        project: fixture.row.project, slug: fixture.row.slug,
+        argv: [
+          "hive", "run", fixture.row.slug, "--project", fixture.row.project,
+          "--stage", fixture.row.stage
+        ],
+        requestor: "healer",
+        trigger: "recoverable_dependency_failure",
+        expected_cleared_marker_id: "marker-1",
+        request_id: "abc12345",
+        state_home: fixture.state_home, now: fixture.now
+      )
+
+      result = fixture.retryer(history: history)
+                      .tick([ fixture.row ], now: fixture.now + 1).first
+
+      assert_equal "retry_queued", result.action
+      assert_equal "abc12345", result.request_id
+      assert_equal :none, Hive::Markers.current(fixture.state_file).name
+      pending = Hive::Daemon::DispatchRequestQueue.pending(
+        state_home: fixture.state_home
+      )
+      assert_equal [ "abc12345" ], pending.map(&:request_id)
+    end
+  end
+
+  def test_dry_run_and_duplicate_rows_do_not_over_mutate
+    with_fixture do |fixture|
+      dry = fixture.retryer(dry_run: true)
+                   .tick([ fixture.row, fixture.row ], now: fixture.now)
+
+      assert_equal 1, dry.length
+      assert_equal "would_retry", dry.first.action
+      assert_equal :error, Hive::Markers.current(fixture.state_file).name
+      refute Dir.exist?(fixture.state_home)
+      assert_empty Hive::Daemon::DispatchRequestQueue.pending(state_home: fixture.state_home)
+      refute File.exist?(File.join(fixture.folder, "events.jsonl"))
+      refute File.exist?(File.join(fixture.folder, "status.md"))
+    end
+  end
+
+  def test_probe_cache_reuses_unchanged_health_until_fallback_and_bypasses_on_signal_change
+    with_fixture do |fixture|
+      calls = 0
+      cheap = "cheap-a"
+      factory = lambda do |_row, _decision|
+        probe = FakeProbe.new(self.class.aggregate(fixture.reason, "health-a"))
+        probe.define_singleton_method(:cheap_fingerprint) { |reason:| cheap }
+        probe.define_singleton_method(:call) do |reason:|
+          calls += 1
+          aggregate
+        end
+        probe
+      end
+      retryer = Hive::Daemon::AutoRetry.new(
+        policy: fixture.policy, probe_factory: factory,
+        state_home: fixture.state_home, dry_run: true
+      )
+
+      retryer.tick([ fixture.row ], now: fixture.now)
+      retryer.tick([ fixture.row ], now: fixture.now + 300)
+      retryer.tick([ fixture.row ], now: fixture.now + 599)
+      assert_equal 1, calls
+
+      retryer.tick([ fixture.row ], now: fixture.now + 600)
+      assert_equal 2, calls
+
+      cheap = "cheap-b"
+      retryer.tick([ fixture.row ], now: fixture.now + 601)
+      assert_equal 3, calls
+    end
+  end
+
+  def test_probe_cache_is_scoped_to_the_task_across_ticks
+    with_fixture do |fixture|
+      calls = 0
+      factory = lambda do |_row, _decision|
+        probe = FakeProbe.new(self.class.aggregate(fixture.reason, "health-a"))
+        probe.define_singleton_method(:call) do |reason:|
+          calls += 1
+          aggregate
+        end
+        probe
+      end
+      retryer = Hive::Daemon::AutoRetry.new(
+        policy: fixture.policy, probe_factory: factory,
+        state_home: fixture.state_home, dry_run: true
+      )
+      other = Hive::Daemon::StatusConsumer::Row.new(**fixture.row.to_h.merge(
+        id: 43,
+        slug: "other-task",
+        folder: File.join(File.dirname(fixture.folder), "other-task")
+      ))
+
+      retryer.tick([ fixture.row ], now: fixture.now)
+      retryer.tick([ other ], now: fixture.now + 1)
+
+      assert_equal 2, calls
+    end
+  end
+
+  def test_same_project_reason_checks_tick_cache_before_building_probe_runner
+    with_fixture do |fixture|
+      factory_calls = 0
+      cheap_calls = 0
+      probe_calls = 0
+      factory = lambda do |_row, _decision|
+        factory_calls += 1
+        probe = FakeProbe.new(self.class.aggregate(fixture.reason, "health-a"))
+        probe.define_singleton_method(:cheap_fingerprint) do |reason:|
+          cheap_calls += 1
+          "cheap"
+        end
+        probe.define_singleton_method(:call) do |reason:|
+          probe_calls += 1
+          aggregate
+        end
+        probe
+      end
+      retryer = Hive::Daemon::AutoRetry.new(
+        policy: fixture.policy, probe_factory: factory,
+        state_home: fixture.state_home, dry_run: true
+      )
+      same_project_context = Hive::Daemon::StatusConsumer::Row.new(**fixture.row.to_h.merge(
+        id: 43,
+        slug: "other-task",
+        folder: File.join(File.dirname(fixture.folder), "other-task"),
+        marker_attrs: fixture.row.marker_attrs.merge("marker_id" => "marker-2")
+      ))
+      other_project_context = Hive::Daemon::StatusConsumer::Row.new(**fixture.row.to_h.merge(
+        project: "other-project",
+        id: 44,
+        slug: "third-task",
+        folder: File.join(File.dirname(fixture.folder), "third-task"),
+        marker_attrs: fixture.row.marker_attrs.merge("marker_id" => "marker-3")
+      ))
+
+      retryer.tick(
+        [ fixture.row, same_project_context, other_project_context ],
+        now: fixture.now
+      )
+
+      assert_equal 2, factory_calls
+      assert_equal 2, cheap_calls
+      assert_equal 2, probe_calls
+    end
+  end
+
+  def test_unchanged_negative_decisions_are_audited_once_per_ten_minutes
+    with_fixture do |fixture|
+      aggregate = self.class.aggregate(fixture.reason, "unhealthy")
+      aggregate.healthy = false
+      aggregate.probes.first.healthy = false
+      audits = []
+      retryer = Hive::Daemon::AutoRetry.new(
+        policy: fixture.policy,
+        probe_factory: ->(_row, _decision) { FakeProbe.new(aggregate) },
+        state_home: fixture.state_home,
+        dry_run: true,
+        audit: ->(**attrs) { audits << attrs }
+      )
+
+      retryer.tick([ fixture.row ], now: fixture.now)
+      retryer.tick([ fixture.row ], now: fixture.now + 599)
+      assert_equal 1, audits.length
+
+      retryer.tick([ fixture.row ], now: fixture.now + 600)
+      assert_equal 2, audits.length
+      assert_equal 1, retryer.instance_variable_get(:@negative_audits).length
+      refute File.exist?(File.join(fixture.folder, "events.jsonl"))
+    end
+  end
+
+  def test_policy_denial_is_audited_and_row_exceptions_are_isolated
+    with_fixture do |fixture|
+      audits = []
+      denied = FakePolicyDecision.new(
+        eligible: false, action: "worktree_dirty", rationale: "unsafe"
+      )
+      retryer = Hive::Daemon::AutoRetry.new(
+        policy: FakePolicy.new(denied),
+        probe_factory: ->(*) { raise "must not probe" },
+        state_home: fixture.state_home,
+        audit: ->(**attrs) { audits << attrs }
+      )
+      assert_equal "worktree_dirty",
+                   retryer.tick([ fixture.row ], now: fixture.now).first.action
+      assert_equal "worktree_dirty", audits.first[:action]
+
+      exploding = Object.new
+      exploding.define_singleton_method(:evaluate) { |_row| raise "policy exploded" }
+      retryer = Hive::Daemon::AutoRetry.new(
+        policy: exploding,
+        probe_factory: ->(*) { raise "must not probe" },
+        state_home: fixture.state_home,
+        audit: ->(**attrs) { audits << attrs }
+      )
+      result = retryer.tick([ fixture.row ], now: fixture.now).first
+      assert_equal "coordinator_error", result.action
+      assert_includes result.rationale, "policy exploded"
+    end
+  end
+
+  def test_reservation_failure_and_claimed_marker_race_fail_closed
+    with_fixture do |fixture|
+      decision = Hive::Daemon::AutoRetryHistory::Decision.new(
+        eligible: true, attempt: 1, action: "retry_eligible", rationale: "ready"
+      )
+      history = FailedReservationHistory.new(decision)
+      result = fixture.retryer(history: history)
+                      .tick([ fixture.row ], now: fixture.now).first
+      assert_equal "reservation_failed", result.action
+      assert_equal :error, Hive::Markers.current(fixture.state_file).name
+
+      result = fixture.retryer(
+        markers: RacingMarkers, request_queue: ClaimedRaceQueue
+      ).tick([ fixture.row ], now: fixture.now).first
+      assert_equal "marker_race", result.action
+      assert_equal "marker changed after request was claimed", result.rationale
+    end
+  end
+
+  def test_audit_sink_argument_error_does_not_abort_dry_run
+    with_fixture do |fixture|
+      retryer = fixture.retryer(
+        dry_run: true,
+        audit: ->(**) { raise ArgumentError, "bad audit sink" }
+      )
+
+      assert_equal "would_retry",
+                   retryer.tick([ fixture.row ], now: fixture.now).first.action
+    end
+  end
+
+  private
+
+  Fixture = Struct.new(
+    :folder, :state_file, :state_home, :row, :now, :reason, :policy,
+    keyword_init: true
+  ) do
+    def retryer(fingerprint: "health-a", markers: Hive::Markers,
+                request_queue: Hive::Daemon::DispatchRequestQueue, dry_run: false,
+                history: Hive::Daemon::AutoRetryHistory.new, audit: nil,
+                events: Hive::Events)
+      aggregate = AutoRetryTest.aggregate(reason, fingerprint)
+      Hive::Daemon::AutoRetry.new(
+        policy: policy,
+        probe_factory: ->(_row, _decision) { AutoRetryTest::FakeProbe.new(aggregate) },
+        state_home: state_home,
+        markers: markers,
+        request_queue: request_queue,
+        events: events,
+        dry_run: dry_run,
+        history: history,
+        audit: audit
+      )
+    end
+
+    def restore_marker(marker_id)
+      attrs = {
+        "reason" => reason, "marker_id" => marker_id,
+        "message" => "dependency failed"
+      }
+      Hive::Markers.set(state_file, :error, attrs)
+      row.marker_attrs = attrs
+      policy.decision.marker_id = marker_id
+    end
+  end
+
+  def with_fixture
+    with_tmp_dir do |dir|
+      folder = File.join(dir, "task")
+      state_home = File.join(dir, "state-home")
+      FileUtils.mkdir_p(folder)
+      state_file = File.join(folder, "execute.md")
+      reason = "implementer_failed"
+      marker_id = "marker-1"
+      attrs = { "reason" => reason, "marker_id" => marker_id, "message" => "dependency failed" }
+      Hive::Markers.set(state_file, :error, attrs)
+      row = Hive::Daemon::StatusConsumer::Row.new(
+        project: "demo", id: 42, slug: "retry-task", stage: "4-execute",
+        marker: "error", marker_attrs: attrs, folder: folder,
+        state_file: state_file, action: "error"
+      )
+      decision = FakePolicyDecision.new(
+        eligible: true, action: "eligible", rationale: "safe",
+        reason: reason, marker_id: marker_id, task: Object.new
+      )
+      fixture = Fixture.new(
+        folder: folder, state_file: state_file, state_home: state_home,
+        row: row, now: Time.utc(2026, 7, 24, 12), reason: reason,
+        policy: FakePolicy.new(decision)
+      )
+      yield fixture
+    end
+  end
+
+  def read_events(folder)
+    path = File.join(folder, "events.jsonl")
+    return [] unless File.exist?(path)
+
+    File.readlines(path, chomp: true).map { |line| JSON.parse(line) }
+  end
+
+  def self.aggregate(reason, fingerprint)
+    probe = Hive::Daemon::AutoRetryProbe::ProbeResult.new(
+      name: "required_doctor", healthy: true, exit_status: 0,
+      timed_out: false, duration_ms: 1, stdout: "", stderr: "",
+      rationale: "healthy"
+    )
+    Hive::Daemon::AutoRetryProbe::Aggregate.new(
+      reason: reason, healthy: true, probes: [ probe ],
+      fingerprint: fingerprint, cheap_fingerprint: "cheap"
+    )
+  end
+end
